package mmkurssit;

//import java.io.OutputStream;
import java.io.PrintStream;

import apumetodit.RandomNumero;

/**
 * Yksittäiset tapaaminen-oliot
 * @author aichi
 * @version 25 Feb 2025
 *
 */
public class Tapaaminen {

    //Attribuutit============================================================
    
    private int tapaaminenID;
    private int kID;//kurssin ID, johon tapaaminen liittyy
    private int paiva;
    private int kkausi;
    private int vuosi;//miten kannattaa säilyttää, jos haluan käyttää date-picker-funktio?
    private int hour;
    private int min;
    private int kesto = 90;//oletuskena 90min kesto
    private String paikka = "";
    private String muu = "";
    private int randomNimi;//testia varten! Ota pois loppuvaiheessa!!!
    
    private static int nextmID = 1;//next tapaaminen ID
    
    //=========================================================================
    
    
    /**
     * Test konstructor, poista lopussa!!!
     */
    public Tapaaminen() {
        this.kID = 1;
    }
    
    /** Tapaamisen alustus 
     * @param kurssiID kurssin ID, johon tapaaminen liittyy
     */
    public Tapaaminen(int kurssiID) {
        this.kID = kurssiID;
    }
    /**
     * Apumetodi, jolla saadaan täytettyä testiarvot kurssille.
     * TODO: POISTA, kun kaikki toimii!!
     * 
     */
    public void tayta() {
        this.randomNimi = RandomNumero.rand(1,100);
        this.paiva = 16;
        this.kkausi = 3;
        this.vuosi = 2025;
        this.hour = 16;
        this.min = 30;
        this.kesto = 90;
        this.paikka = "B248";
        this.muu = "Välipala mukaan";
        
    } 
    
    
    /**
     * Tulostetaan tapaamisen tiedot
     * @param os teitovirta johon tulostetaan 
     */
/*    public void tulosta(OutputStream os) {
        //tulsota(new PrintStream(os));
    }
 */   
    
    /**
     * Tulostetaan tapaamisen tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("Coruse ID: %3d", kID));
        out.println(String.format("Meeting ID: %03d", tapaaminenID) + String.format(" nimiksi: %3d", randomNimi));
        out.println(milloin());
        out.println("Aloitusaika: " + aloitusaika());
        out.println("Loppuu: "+ lopetusaika());
        out.println("Paikka: " + missa());
        out.println("HUOM! "+muu);
    }

    
    /**
     * @return tapaamisen paikka
     */
    private String missa() {
        return this.paikka;
    }

    
    /**
     * @return tapaamisen lopetusaika laskettuna ja string-muotona
     */
    private String lopetusaika() {
        int loppuh = 0;
        int loppumin = this.min + this.kesto;
        
        while(loppumin >= 60){
            loppumin = loppumin -60;
            loppuh++;
        }
        loppuh = loppuh + this.hour;
        //return String.format("%02d", loppuh)+":"+String.format("%02d", loppumin);
        return String.format("%02d:%02d", loppuh, loppumin);
    }


    /**
     * @return tapaamisen päivämäärät stringina
     */
    private String milloin() {
        //TODO: lisaa pv ja kk takistuskoodi
        if (this.paiva > 31 || kkausi >12) return "Wrong date or month";
        
        return this.paiva +"."+this.kkausi+"."+this.vuosi;
    }
    
    
    /**
     * @return tapaamisen aloitusaika stringina
     */
    private String aloitusaika() {
        if (hour>22 || min >60) return "Check the time";
        return this.hour+":"+this.min;
    }


    /**
     * Antaa tapaamiselle seuraavan tunnusnumeron
     * @example
     * <pre name="test">
     *    Tapaaminen saksa_1 = new Tapaaminen(3);
     *      saksa_1.getmID() === 0;
     *      saksa_1.rekisteroi();
     *    Tapaaminen ohjelmointi_1 = new Tapaaminen(4);
     *      ohjelmointi_1.rekisteroi();
     *    int n1 = saksa_1.getmID();
     *    int n2 = ohjelmointi_1.getmID();
     *    n1 === 1;
     *    n2 === 2;
     * </pre>
     */
    public void rekisteroi() {
        this.tapaaminenID = nextmID;
        nextmID++;
    }
    
    
    /**
     * @return kyseisen tapaamisen ID
     */
    public int getmID() {
        return this.tapaaminenID;
    }
    
    
    /**
     * @return kyseisen tapaamisen kID (eli kurssin ID), joka kertoo mihin kurssiin kyseinen tapaaminen liittyy
     */
    public int getkID() {
        return this.kID;
    }
    
    
    //==========================================================================
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        
        Kurssi japani3 = new Kurssi();
        Kurssi ohjelmointi2 = new Kurssi();
        Tapaaminen japani3_1 = new Tapaaminen(japani3.getID());
        Tapaaminen ohjelmointi2_1 = new Tapaaminen(ohjelmointi2.getID());
        
        japani3_1.rekisteroi();
        japani3_1.tayta();
        
        ohjelmointi2_1.rekisteroi();
        ohjelmointi2_1.tayta();
        
        japani3_1.tulosta(System.out);
        ohjelmointi2_1.tulosta(System.out);
    
    }

}
